<template>
	<div id="app">
		<div class="appbar"><h2>Ejemplo artículos</h2></div>
		<lista-articulos
			class="articles"
			@article-selected="showArticle"
		></lista-articulos>
		<transition name="article-transition" mode="in-out">
			<articulo
				v-if="article"
				class="article"
				:article="article"
				@close="closeArticle"
			></articulo>
		</transition>
		<mi-footer></mi-footer>
	</div>
</template>

<script>
	import ListaArticulos from "./components/ListaArticulos";
	import Articulo from "./components/Articulo.vue";
	import MiFooter from "./components/MiFooter";

	export default {
		name: "App",
		data() {
			return {
				article: false
			};
		},
		components: { ListaArticulos, Articulo, MiFooter },
		methods: {
			showArticle(id) {
				//Hack para que el ratón se muestre cargando
				document.querySelector(".lista-articulos").style.cssText =
					"cursor: wait";
				this.$store.dispatch("fetchArticle", id).then(() => {
					//lo ponemos normal
					document.querySelector(".lista-articulos").style.cssText =
						"cursor: pointer";

					this.article = this.$store.getters.getArticle;
				});
			},
			closeArticle() {
				this.article = false;
			}
		}
	};
</script>

<style lang="scss">
	$appbar-height: 64px;

	* {
		margin: 0;
		padding: 0;
		box-sizing: border-box;
	}

	#app {
		font-family: Avenir, Helvetica, Arial, sans-serif;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		text-align: center;
		color: #2c3e50;
		display: flex;
		flex-direction: column;
		min-height: 100vh;
		height: 100%;
		background-color: #f3f3f3;
		transition: height 1s ease-in-out;
		position: relative;
		overflow-x: hidden;
		overflow-y: scroll;

		.appbar {
			position: absolute;
			display: flex;
			justify-content: flex-start;
			align-items: center;
			padding: 0 32px;

			height: $appbar-height;
			width: 100vw;

			background-color: #2c3e50;
			color: #fafafa;
			z-index: 100;
		}

		.articles {
			display: flex;
			flex-grow: 1;

			position: relative;

			margin: calc(#{$appbar-height} + 32px) 32px 32px 32px;
			padding: 32px;
		}

		.article {
			position: absolute;
			min-height: 100%;
			width: 100%;
			padding-top: calc(#{$appbar-height} + 32px);
		}
	}

	/*ANIMACIONES */
	.article-transition-enter {
		transform: translateY(100vh);
	}

	.article-transition-enter-active {
		transition: transform 1s ease-in-out;
	}

	.article-transition-enter-to {
		transform: translateY(0);
	}

	.article-transition-leave-active {
		transform: translateY(100vh);
		transition: transform 1s ease-in-out;
	}
</style>
